#include <stdio.h>
#include <math.h>
#include <rpc/rpc.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Dialog.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/X.h>
#include <X11/cursorfont.h>
#include <X11/extensions/shape.h>
#include "pgmrc.h"

#define LOGO_TITLE "Logo"
#define PROG_NAME "Pygmalion"
#define PROG_NAME1 "Neural Network"
#define PROG_NAME2 "Programming Environment"
#define PART_INTRO "The Partners in the Pygmalion Neurocomputing Project are:"
#define PARTNERS "Thomson-CSF, CSELT, CTI, ENS, INESC, IRIAC, Philips, SEL, UCL"
#define VERSION "Version 1.02  [Beta Release]"
#define COPYRIGHT "Copyright  February 1990,  University College London"


Display *topdpy;
Window topwin;
Window logo_win;
XSizeHints xshints;
XWMHints xwmh;
XSetWindowAttributes xswa;
int logo_x, logo_y;
unsigned int logo_width, logo_height;
unsigned int bitmapwidth, bitmapheight;
Pixmap logo_pixmap;
int bitmap_xhot, bitmap_y_hot;
int logo_status;
Pixmap logo_window_pixmap;
GC logo_gc;
Window logo_root, parent_root;
unsigned int logo_win_width, logo_win_height, logo_win_depth, logo_win_border;
int logo_win_x, logo_win_y;
int parent_x, parent_y;
unsigned int parent_width, parent_height, parent_border,parent_depth;

/* two lines here are temp until these are inc in Family */
Bool prev_sys_conn, prev_net_conn, prev_layer_conn, prev_cluster_conn;
Bool prev_matrix_layer;


Display *dpy;			/* the display we are connected to */
Window gra_win;			/* the graphic area of the level widget */
GC gc;                          /* graphics context */
XFontStruct *fontstruct;	/* pointer to the font structure */
unsigned long fonth, pad;	/* font height and padding between font and border if required */
unsigned long fg, bg, bd;	/* for the foreground, background, and border colors */
unsigned long bw;		/* for the border width if required */
XEvent event;			/* will need this to select the events thought necessary to act on */
XGCValues gcv;                  /* structure for the graphic context */
XSetWindowAttributes xswa;	/* saves a lot of typing */
XtValueMask valuemask;		/* maybe required for the widget interactions */
XWindowAttributes xwa;          /* Temporary window attribute */

Colormap cmap; 		/* for the mo this is here */
Colormap default_cmap;
Colormap pgm_cmap;

XColor my_white;
XColor my_black;

XColor my_yellow;
XColor my_red;
XColor my_blue;
XColor my_green;

XColor my_bg;
XColor my_bg1;
XColor my_fg2;
XColor my_fg1;
XColor my_bg2;
XColor my_fg;
XColor my_drawing_color;

Font my_font;
XFontStruct *my_norm_font;
XFontStruct *my_little_font;
XFontStruct *my_big_font;
int string_width;

Status result;
unsigned long plane_mask[];
unsigned long pixel[];

int colormap_cell;

char r, g, b;		/*  flags for shading functions */

Cursor level_window_cursor;
Cursor level_window_wait_cursor;

/* the folowing offsets are for the colors defined in the default cmap by pgm - 
 * it needs 190 cells or it will bomb out - not very friendly, but dynamic rearrangement
 * will have to wait until after ESPRIT week
 */
#define COLOR_STEP 	177  /* spread 20 colors over 35536 so ignore very dim or bright bits */
#define COLOR_OFFSET	20000  /* don't want to use the lower 20000 values of a colour - too close to black! */
#define SINGLE_COLOR_STEP 1500
#define SINGLE_COLOR_OFFSET	25000
#define PGM_OFFSET	0
#define BB_OFFSET	2

char level;

#define False 0
#define True 1

extern int rc_read();
extern int rc_write();
extern void rc_update();
extern char *rc[];

char sys_low_color;
char sys_high_color; 
char net_low_color;
char net_high_color; 
char layer_low_color; 
char layer_high_color; 
char cluster_low_color; 
char cluster_high_color; 
char neuron_low_color;
char neuron_high_color;

#define INVBUF "on"
